; Altirra Acid800 test suite
; Copyright (C) 2010 Avery Lee, All Rights Reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE. 

		_SAP_HEADER "POKEY: Asynchronous receive mode"

		opt		h+o+

		icl		'library.s'

		org		$2000

main:
		ldy		#>testname
		lda		#<testname
		jsr		_testInit
		
		;turn interrupts off
		jsr		_screenOff
		jsr		_interruptsOff
		
		;disable asynchronous receive mode on POKEY and check that we can
		;see timer 4 interrupts
		mva		#$03 skctl
		mva		#0 audc4
		mva		#$02 audf4
		mva		#$00 audctl
		mva		#$00 irqen
		
		sta		stimer
		mva		#$04 irqen
		
		jsr		checkirq
		
		_ASSERTA $01, c"Timer #4 IRQ did not fire."
		
		;clear the interrupt
		mva		#$00 irqen
		
		;enable asynchronous receive mode on POKEY
		mva		#$13 skctl
		
		;re-enable the interrupt and see if we can see it; we shouldn't,
		;since POKEY is waiting for a start bit
		sta		stimer
		mva		#$04 irqen
		
		jsr		checkirq

		_ASSERTA $00, c"Timer #4 IRQ fired with async recv mode active."
		
		jmp		_testPassed
	
.proc checkirq
		ldy		#$20
		ldx		#0
checkloop:
		bit		irqst
		beq		detected
		dex
		bne		checkloop
		dey
		bne		checkloop
		
		txa
		rts
		
detected:
		lda		#1
		rts
.endp
		
		
testname:
		dta		c"POKEY: Asynchronous receive mode",0

		run		$2000
		end
